findU4 <- function(NPmle, ConfInt, LogLikfn2, Pfun2, dataMat)
{
#### NPmle:  should be a vector of length 3, they are the NPmle of beta1, beta2, and a=alpha.
#### ConfInt:  should be a vector of length 4.... the length of four 90% confidence intervals, for
#### beta1, beta2, a and lambda. It do not have to be exact. But they provides good initial step.
#### LogLikfn2:  is a function that takes two inputs: para + dataMat, and returns the loglik value
#### Pfun2:  is a function that takes the input of 4 parameter values (beta1,beta2,a and Mulam) and 
####         returns a parameter that we wish to find conf Interval Upper Value. [also input X value]
#### dataMat:  is only used for the function LogLikfn( ).
####
#### Output:  Max Pfun; corresponding beta1, beta2, lambda and Mulam. and Loglik value.
    if( length(NPmle) != 3) stop("NPmle must of length 3")
    MaxValue <- LogLikfn2(c(NPmle, 0), dataMat)$Loglik    ## since the NPMLE of lam is 0 always
    stepsize <- ConfInt/2
    b1vec <- NPmle[1] + stepsize[1] * (1:8 - 4.5)   ### pertubations
    b2vec <- NPmle[2] + stepsize[2] * (1:8 - 4.5)
    avec <- NPmle[3] + stepsize[3] * (1:8 - 4.5)
    lamvec <- stepsize[4] * (1:8 - 4.5)

    temp <- matrix(NA, nrow = 6, ncol = 4096)   ## 8*8*8*8 = 512*8 = 4096
    temp[1, ] <- rep(b1vec, each=512)           ## 8*8 = 64, 8*8*8=512
    temp[2, ] <- rep(rep(b2vec, each=64), 8)
    temp[3, ] <- rep(rep(avec, each=8), 64)
    temp[4, ] <- rep(lamvec, 512)
    for (i in 1:8) for (j in 1:8) for (k in 1:8) for (r in 1:8) {
        ind <- (i - 1)*512 + (j - 1)*64 + (k-1)*8 + r
        mtemp <- LogLikfn2(mle=c(b1vec[i],b2vec[j],avec[k],lamvec[r]),dataMat)
        temp[5, ind] <- mtemp$Mulam
        temp[6, ind] <- mtemp$Loglik
    }

    subsetInd <- (temp[6, ] >= (MaxValue - 3.84/2))
    ParaTrials <- temp[, subsetInd]
    TrialValues <- Pfun2(b1=ParaTrials[1,], b2=ParaTrials[2,], a=ParaTrials[3,], X=0.5, Mulam=ParaTrials[5,])
    maxInd <- which.max(TrialValues)
    PfunU <- TrialValues[maxInd]
    #### Pfunstep <- 3
    maxPara <- ParaTrials[, maxInd]
    print(c(PfunU, maxPara))

    for (N in 1:20) {                #### may be more steps?
        if( sum(subsetInd) < 3000 ) stepsize <- stepsize/1.6        #### may be do not shorten the step as fast?
        ####if( abs(PfunU - PfunUold) < Pfunstep )  stepsize <- stepsize/2
        ####Pfunstep <- abs(PfunUold - PfunU)
        b1vec <- maxPara[1] + stepsize[1]*(1:8 - 4.5)
        b2vec <- maxPara[2] + stepsize[2]*(1:8 - 4.5)
        avec <- maxPara[3] + stepsize[3]*(1:8 - 4.5)
        lamvec <- maxPara[4] + stepsize[4]*(1:8 - 4.5)
        temp[1, ] <- rep(b1vec, each=512)
        temp[2, ] <- rep(rep(b2vec, each=64), 8)
        temp[3, ] <- rep(rep(avec, each=8), 64)
        temp[4, ] <- rep(lamvec, 512)
     for (i in 1:8) for (j in 1:8) for (k in 1:8) for (r in 1:8){
            ind <- (i-1)*512 + (j-1)*64 + (k-1)*8 + r
            mtemp <- LogLikfn2(mle=c(b1vec[i], b2vec[j], avec[k], lamvec[r]), dataMat)
            temp[5, ind] <- mtemp$Mulam
            temp[6, ind] <- mtemp$Loglik 
        }
        subsetInd <- (temp[6, ] >= (MaxValue - 3.84/2))
        ParaTrials <- temp[, subsetInd]
        TrialValues <- Pfun2(b1=ParaTrials[1,], b2=ParaTrials[2,], a=ParaTrials[3,], X=0.5, Mulam=ParaTrials[5,])
        maxInd <- which.max(TrialValues)
        PfunU <- TrialValues[maxInd]
        maxPara <- ParaTrials[, maxInd]
        print(c(PfunU, maxPara))
    }
    list(Upper = PfunU, maxParameterNloglik = maxPara)
}
